/*
Copyright (c) 2002-2011 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: 
*/ 
#ifndef __GRAPHICSEXAMPLE_ANIMATIONCONTAINER_H__
#define __GRAPHICSEXAMPLE_ANIMATIONCONTAINER_H__

// INCLUDES
#include <COECNTRL.H>
#include <ImageConversion.h>

#include "Gif_AnimationReader.h"

// CLASS DECLARATION

class CAnimationContainer : public CCoeControl,MAniReaderCallBack
	{
public: // public constructors and destructor
	static CAnimationContainer* NewL( const TRect& aRect, const TDesC& aFileName);
	static CAnimationContainer* NewLC( const TRect& aRect, const TDesC& aFileName);
	~CAnimationContainer();
protected: //MAniReaderCallBack callback function for CAniFrame_Reader
	void AppendFrameL(CFbsBitmap& aImage,CFbsBitmap& aMask,TRect aArea, TBool aReDraw);
private: // // From CoeControl
	void Draw( const TRect& aRect ) const;
	void HandleResourceChange(TInt aType);

	// private constructor
	void ConstructL( const TRect& aRect, const TDesC& aFileName);
	// callback function for the periodic timer
	static TInt DoReadNextFrameL(TAny* aPtr);
private:
	TInt 				iCurrImg,iCurrCount;// count of frames & current index
	CFbsBitmap*			iBitmap;		  // image that animation gets drawn to
	CFbsBitGc* 			iGraphicsContext; // context to draw the animation
	CFbsBitmapDevice* 	iBitmapDevice; 	  // device for the context
	CAniFrame_Reader*	iAniFrame_Reader;// animation frame reade
	CPeriodic* 			iFrameReadTimer; // timer for frames
	};

#endif // __GRAPHICSEXAMPLE_ANIMATIONCONTAINER_H__

// End of File
