/*
Copyright (c) 2002-2011 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: 
*/ 
#ifndef __GRAPHICSEXAMPLE_CONTROLSCONTAINER_H__
#define __GRAPHICSEXAMPLE_CONTROLSCONTAINER_H__

// INCLUDES
#include <COECNTRL.H>

class CAnimationControl;
class CImageControl;

_LIT(KTxImage3			,"C:\\data\\Food.jpg");

_LIT(KTxBitmap2			,"C:\\data\\Bitmap2.mbm");
_LIT(KTxAnimation3		,"C:\\data\\HiThere.gif");


// CLASS DECLARATION

class CControlsContainer : public CCoeControl
	{
public: // public constructors and destructor
	static CControlsContainer* NewL( const TRect& aRect );
	static CControlsContainer* NewLC( const TRect& aRect );
	~CControlsContainer();
private: // From CoeControl
	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);
	TInt CountComponentControls() const;
	CCoeControl* ComponentControl( TInt aIndex ) const;
	void Draw( const TRect& aRect ) const;

	void HandleResourceChange(TInt aType);
	void SizeChanged();
	// private constructor
	void ConstructL( const TRect& aRect );
private:
	CImageControl*		iImageControl;
	CAnimationControl*	iAnimationControl;
	CFbsBitmap*			iBitmap;
	TRect 				iImageRect,iAnimationRect;
	TRect 				iBitmapRect,iBitmapRect2;
	TInt				iSelected;
	};

#endif // __GRAPHICSEXAMPLE_CONTROLSCONTAINER_H__

// End of File
